<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="75%"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="form-dialog-box"
    v-loading="loading"
    :element-loading-text="loadingText"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0)">
      <div
        v-loading="loading"
        :element-loading-text="''"
        element-loading-spinner="''"
        element-loading-background="rgba(0, 0, 0, 0.8)"
        >
        <el-form :model="form" ref="form" :rules="rules" label-width="200px">
          <div class="form-title"><span>基本信息</span></div>
          <el-form-item label="等级名称：" prop="name">
            <el-input style="width: 350px;" v-model="form.name" placeholder="请输入等级名称" maxlength="50" show-word-limit />
          </el-form-item>
          <el-form-item label="所需积分值：" prop="upIntegral">
            <el-input-number style="width: 350px;" v-model="form.upIntegral" controls-position="right" placeholder="请输入所需积分值"></el-input-number>
          </el-form-item>
          <el-form-item label="等级图片" prop="logo">
            <div style="display: flex;">
              <div 
              v-for="(item,index) in form.logo" 
              :key="index"
              style="width: 100px; height: 100px;position: relative;border: 1px solid #999;border-radius: 5px;margin-right: 20px;">
                <el-image 
                  style="width: 100%; height: 100%"
                  :src="item" 
                  :preview-src-list="form.logo">
                </el-image>
                <span @click="handleRemove(index)" style="position: absolute;top: -15px;right: -15px;color: red;font-size: 24px;z-index: 999;cursor: pointer;">
                  <i class="el-icon-error"></i>
                </span>
              </div>
              <div 
              style="width: 100px; height: 100px;" 
              v-if="!form.logo||form.logo.length<1"
              v-loading="actionUrlLoading"
              element-loading-text="上传中..."
              element-loading-spinner="el-icon-loading"
              element-loading-background="rgba(0, 0, 0, 0.8)"
              >
                <el-upload
                  class="avatar-uploader"
                  :action="actionUrl"
                  :data="{
                    bucket: 'tourism'
                  }"
                  :show-file-list="false"
                  :before-upload="beforeAvatarUpload"
                  :on-success="handleAvatarSuccess"
                  :on-progress="handleAvatarProgress"
                  :disabled="actionUrlLoading"
                  :on-error="handleAvatarError"
                  >
                  <i class="el-icon-plus avatar-uploader-icon"></i>
                </el-upload>
              </div>
              
            </div>
            <span>建议尺寸XXX*XXX,支持jpg、png,支持100KB大小以内的图片上传</span>
          </el-form-item>
          <div class="form-title"><span>会员权益</span></div>
          <el-form-item label="折扣权益：">
            <div style="display: flex;align-items: center;">
              <el-form-item label="基本折扣：" prop="discount" label-width="100px">
                <el-input-number style="width: 150px;" v-model="form.discount" controls-position="right" placeholder="请输入基本折扣"></el-input-number>
                <span style="padding-bottom: 15px;">%</span>
              </el-form-item>
              <el-button style="margin-left: 15px;" v-if="!form.classifyList||form.classifyList.length==0" type="primary" @click="addClassifyList">添加单品</el-button>
            </div>
            
            <div v-for="(item,index) in form.classifyList" :key="index" style="margin-top: 10px;display: flex;align-items: center;">
              <el-form-item label="单品折扣：" label-width="100px">
                <el-select v-model="form.classifyList[index].classifyId" clearable placeholder="请选择单品">
                  <el-option
                    v-for="item in scenicAreaProducts"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value">
                  </el-option>
                </el-select>
                <el-input-number style="width: 150px;margin-left: 20px;" v-model="form.classifyList[index].discount" placeholder="请输入单品折扣" controls-position="right"></el-input-number>
                <span style="padding-bottom: 15px;">%</span>
              </el-form-item>
              <el-button style="margin-left: 15px;" v-if="form.classifyList.length==(index+1)" type="primary" @click="addClassifyList">添加单品</el-button>
              <el-button style="margin-left: 15px;" type="danger" @click="clearClassifyList(index)">移除</el-button>
            </div>
          </el-form-item>
          <el-form-item label="积分权益：">
            <el-form-item label="积分成长系数：" prop="integralRatio" label-width="120px">
              <el-input-number style="width: 150px;" v-model="form.integralRatio" placeholder="请输入积分成长系数" controls-position="right"></el-input-number>
              <span style="padding-bottom: 15px;font-size: 12px;color: #ccc;">(会员下单获取积分值=实付金额**积分规则基础系数"会员成长系数会员系数越大，获得成长值越多，建议数值设置不要过大)</span>
            </el-form-item>
          </el-form-item>
          <el-form-item label="专属优惠卷：" prop="couponIdList">
            <el-select v-model="form.couponIdLList" clearable placeholder="请选择专属优惠卷">
              <el-option
                v-for="item in scenicAreaProducts"
                :key="item.value"
                :label="item.label"
                :value="item.value">
                </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="指定产品不参与会员折扣：" prop="goodsIdList">
            <el-select v-model="form.goodsIdList" clearable placeholder="请选择指定产品不参与会员折扣">
              <el-option
                v-for="item in scenicAreaProducts"
                :key="item.value"
                :label="item.label"
                :value="item.value">
                </el-option>
            </el-select>
          </el-form-item>
        </el-form>
      </div>
    </div>
    <span slot="footer" class="dialog-footer" v-if="formStatus==1">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        :loading="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      > 
        {{ loading ? '提交中...' : '保存' }}
      </el-button>
    </span>
    <!-- 添加或修改对话框 End -->
  </el-dialog>
</template>

<script>
import { 
  getTableDeatilsByIdApi,
  updateTableApi,
  addTableApi
 } from '@/api/CURD'

export default {
  name: "addAndEdit",
  dicts: [],
  data() {
    return {
      title: "",
      model: "", // EDIT: 编辑模式 ADD : 新增模式  EDITInit : 编辑模式（需要请求详情）
      open: false,
      loading: false,
      loadingText: "拼命加载数据中...",
      formStatus: null, // 0/null : 加载中 1 : 获取详情成功 2  : 获取详情失败 
      configUrl: {
        add: '/member/memberLevelInfo/insertOrUpdate', // 新增地址
        details: '/member/memberLevelInfo/selectById', // 详情地址
        edit: '/member/memberLevelInfo/insertOrUpdate', // 编辑地址
      },
      form: {
        id: undefined,
      },
      rules: {
        name: [{ required: true, message: "请输入等级名称", trigger: ["change","blur"] }],
        logo: [{ required: true, message: "请上传图片", trigger: ["change","blur"] }],
        upIntegral: [{ required: true, message: "请输入所需积分值", trigger: ["change","blur"] }],
        discount: [{ required: true, message: "请输入基本折扣", trigger: ["change","blur"] }],
        integralRatio: [{ required: true, message: "请输入积分成长系数", trigger: ["change","blur"] }],
      },
      scenicAreaProducts: [],// 景点产品关联

      //  上传文件
      actionUrl: process.env.VUE_APP_BASE_API + process.env.VUE_APP_UPLOAD_IMAGE,
      actionUrlLoading: false,
    };
  },
  methods: {
    async initData(title , model,row){
      this.title = title
      this.open = true
      this.loadingText = "拼命加载数据中..."
      this.loading = true
      this.actionUrlLoading = false
      this.model = model
      this.formStatus = 0
      if(model=='ADD') { // 新增
        this.$set(this,'form',{...row,logo:[]})
        this.formStatus = 1
      }else if(model=='EDIT') { // 新增
        let obj = {
          ...row,
          logo: row.logo?row.logo.split(','):[]
        }
        this.$set(this,'form',obj)
        this.formStatus = 1
      }else if(model=='EDITInit') { // 新增
        await this.getTableDeatilsFun(row)
      }
      this.loading = false
      this.$nextTick(()=>{
        if(this.$refs["form"]) {
          this.$refs["form"].clearValidate();
        }
      })
    },
    /** 获取详情 */
    async getTableDeatilsFun(row) {
      const id = row.id
      this.loading = true
      try {
        let res = await getTableDeatilsByIdApi(this.configUrl.details,{id})
        if(res.code == 200) {
          let obj = {
            ...res.data,
            logo: res.data.logo?res.data.logo.split(','):[],
        }
          this.$set(this,'form',JSON.parse(JSON.stringify(obj)))
          this.formStatus = 1
        }else {
          this.$message.error('获取详情失败!!!');
          this.formStatus = 2
          this.loading = false
          this.open = false;
        }
        this.loading = false
      } catch (error) {
        console.error('获取详情失败!!!!',error)
        this.formStatus = 2
        this.loading = false
        this.open = false;
      }
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.loadingText = "提交数据中..."
          this.loading = true
          if (this.model != 'ADD') {
            addTableApi(
              this.configUrl.edit,{
                ...this.form,
                logo: this.form.logo ? this.form.logo.join(','):''
              }).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("修改失败!!!");
              this.loading = false
            })
          } else {
            addTableApi(this.configUrl.edit,{
                ...this.form,
                logo: this.form.logo ? this.form.logo.join(','):''
              }).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("新增失败!!!");
              this.loading = false
            })
          }
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      if(this.$refs["form"]) {
        this.$refs["form"].clearValidate();
      }
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },

    /**  上传图片 单张  */
    handleAvatarSuccess(response, file, fileList) {
      console.log("res, file",response, file, fileList)
      this.actionUrlLoading = false
      if(response.code == 200) {
        this.form.logo.push(response.data.url)
      }
    },
    beforeAvatarUpload(file) {
      const isLt2M = file.size / 1024 / 1024 < 1;
      let testmsg = file.name.substring(file.name.lastIndexOf('.')+1)
      let typeList = ['png','jepg','jpg']
      const isJPG = typeList.includes(testmsg);
      if (!isJPG) {
        this.$message.error(`上传图片图片只能是 ${typeList} 格式!`);
      }
      if (!isLt2M) {
        this.$message.error('上传图片图片大小不能超过 1MB!');
      }
      return isJPG && isLt2M;
    },
    handleAvatarProgress(){
      this.actionUrlLoading = true
    },
    handleAvatarError() {
      this.actionUrlLoading = false
    },
    handleRemove(index) {
      this.form.logo.splice(index,1)
    },

    /** 填加单品  */
    addClassifyList(){
      let list = []
      if(this.form.classifyList) {
        list = JSON.parse(JSON.stringify(this.form.classifyList))
      }
      list.push({
        classifyId: null,
        discount: null,
        classifyName: null
      })
      this.$set(this.form,'classifyList',list)
    }, 
    /** 移除单品  */
    clearClassifyList(index) {
      this.form.classifyList.splice(index,1)
    }
  },
};
</script>

<style lang="scss" scoped>
.form-dialog-box {
  padding: 0 30px;
  padding: 0 30px;
  min-height: 50vh;
  max-height: 65vh;
  overflow-y: auto;
  >div {
    width: 100%;
    min-height: 50vh;
  }
  .form-title {
    padding: 0 0 10px 0;
    span {
      display: flex;
      color: rgba(65,80,88,1);
      font-size: 16px;
      font-family: SourceHanSansSC;
      font-weight: 700;
      line-height: 23px;
      border-left: 4px solid rgb(22, 132, 252);
      padding-left: 10px;
    }
    
  }
  ::v-deep .ql-editor {
    height: 400px;
  }
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
.el-table{
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}

.area-container {
  min-height: 400px;
}

::v-deep .area-wrap-city.el-cascader {
  line-height: normal;
  .el-input {
    cursor: pointer;
    width: 100% !important;
    height: 28px !important;
    .el-input__inner {
      display: none !important;
    }
    span.el-input__suffix {
      position: inherit !important;
      i.el-input__icon {
        line-height: inherit;
        margin-left: 5px;
      }
    }

    .el-input__wrapper {
      box-shadow: none;
      input {
        display: none;
      }
    }
  }

  .el-cascader__tags {
    display: none;
  }
}

.area-city-popper {
  .el-cascader-panel {
    .el-scrollbar.el-cascader-menu {
      .el-cascader-menu__wrap.el-scrollbar__wrap {
        height: 315px;
      }
    }
  }
}
::v-deep .avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  ::v-deep .avatar-uploader .el-upload:hover {
    border-color: #409EFF;
  }
  ::v-deep .avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 100px;
    height: 100px;
    line-height: 100px;
    text-align: center;
  }
  ::v-deep .avatar {
    width: 100px;
    height: 100px;
    display: block;
  }
</style>
<style>
.custom-class-box {
  z-index: 999999 !important;
}
</style>